package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.service.TowerProjectService;
import com.gxwebsoft.tower.entity.TowerProject;
import com.gxwebsoft.tower.param.TowerProjectParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 项目管理控制器
 *
 * @author 科技小王子
 * @since 2023-05-22 13:30:39
 */
@Api(tags = "项目管理管理")
@RestController
@RequestMapping("/api/tower/tower-project")
public class TowerProjectController extends BaseController {
    @Resource
    private TowerProjectService towerProjectService;

    @PreAuthorize("hasAuthority('tower:towerProject:list')")
    @OperationLog
    @ApiOperation("分页查询项目管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerProject>> page(TowerProjectParam param) {
        // 使用关联查询
        return success(towerProjectService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerProject:list')")
    @OperationLog
    @ApiOperation("查询全部项目管理")
    @GetMapping()
    public ApiResult<List<TowerProject>> list(TowerProjectParam param) {
        // 使用关联查询
        return success(towerProjectService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerProject:list')")
    @OperationLog
    @ApiOperation("根据id查询项目管理")
    @GetMapping("/{id}")
    public ApiResult<TowerProject> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(towerProjectService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerProject:save')")
    @OperationLog
    @ApiOperation("添加项目管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerProject towerProject) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerProject.setUserId(loginUser.getUserId());
        }
        if (towerProjectService.save(towerProject)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:update')")
    @OperationLog
    @ApiOperation("修改项目管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerProject towerProject) {
        if (towerProjectService.updateById(towerProject)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:remove')")
    @OperationLog
    @ApiOperation("删除项目管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerProjectService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:save')")
    @OperationLog
    @ApiOperation("批量添加项目管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerProject> list) {
        if (towerProjectService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:update')")
    @OperationLog
    @ApiOperation("批量修改项目管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerProject> batchParam) {
        if (batchParam.update(towerProjectService, "project_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:remove')")
    @OperationLog
    @ApiOperation("批量删除项目管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerProjectService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
